(define-module (sx-ext gen))
(use-modules  (sx selection-basic) (sx selection)
              (sx property) (sx basic) (sx undo)
              (sx gui-gl) (sx gui-entry) (sx gui-optmenu)
)

(export command-edge)


; add the commands to the sx system
(entry-add-command-list '("edge"))


(define (command-edge)
  ; setup selection mechanism
  (selection-setup selection-object
                   operation-edge-add
                   "Select edge point(s):" 
                   *OPTION_SELECT*
                   'select_obj
                   ; user must select points
                   '(no_empty type_point no_multiple)
                   #f)
)


(define (operation-edge-add)
  (if (= (length *SELECT_LIST*) 2)
    (let* ( (id #f) )
      (undo-add-op-mark)
      ; add the edge
      (set! id (link-add-basic #f (list (cadar *SELECT_LIST*) 
                                        (cadadr *SELECT_LIST*)) #f #t))
      (object-property-set 'l id 'edge '(integer 1) #t)

      ; clear all selection
      (selection-clear)
      ; update the screen
      (gui-update-gl-window #t)
    )
    (gui-entry-add-history " *Two points are required*")
  )
)




