; version 1.2

(use-modules
 (gtk gdk)
 (gtk gtk)
 (open-gl gl)
 (open-gl glu)
 (open-gl gtkgl)
 (sx trackball)         ; this is my implementation
 (sx undo)              ; undo mechanism
 (sx property)          ; object database
 (sx render)            ; opengl rendering
 (sx mouse)             ; mouse tracking and clicking
 (sx basic)             ; basic operations on objects
 (sx menu)              ; menu file parsing and loading
 (sx selection-basic)   ; basic selection mechanism
 (sx view)              ; reentrant viewing commands
 (sx selection)         ; high level selection mechanism
 (sx operation)         ; high level operations
 (sx command)           ; high level user commands
 (sx gui-entry)         ; entry widget handling, main "dispatcher"
 (sx gui-menu)          ; gtk support for menus
 (sx gui-optmenu)       ; gtk support for optional menus
 (sx gui-gl)            ; OpenGL window support
 (sx gui-selection)     ; single object selection with dialog window
 (sx gui-property)      ; property editing with dialog windows
 (sx gui-main)          ; main window creation
;;;
 (sx-ext divide)        ; divides a distance into equal parts
 (sx-ext merge-nodes)   ; merge nodes or separate connected nodes
 (sx-ext surf-closed)   ; check whether a surface is closed
 (sx-ext e-lib)         ; e-lib input and output
 (sx-ext gen)           ; gen format
;  (ice-9 statprof)     ; for profiling
)


; In guile 1.4 "eval" has one argument while in guile 1.5.4 the function with
; one argument is "primitive-eval". (I need a function which evaluates the
; expression in the global environment.)
(load "config.scm")
(display "config module loaded")(newline)


;; optional
;(load "e-lib/e-lib.scm")
;(display "e-lib module loaded")(newline)
;(load "gen/gen.scm")
;(display "gen module loaded")(newline)


(display "---------------------")(newline)


; ####################################################################

(gui-create-main-window)


;;; profiling code
;;; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;    (debug-enable 'debug)
;    (trap-enable 'traps)
;
;    (statprof-reset 0 50000)
;    (statprof-start)
;;; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

(gui-main)

;;; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;    (statprof-stop)
;    (statprof-display)
;;; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


