(define-module (sx gui-menu))
(use-modules (gtk gdk) (gtk gtk) (sx gui-entry) (sx selection))
(export gui-menu-bar-new gui-menu-bar-append gui-menu-new
        gui-menu-item-new gui-menu-separator-new 
        gui-menu-append gui-menu-item-connect gui-submenu-set
)


(define (gui-menu-bar-new)
  (gtk-menu-bar-new)
)

(define (gui-menu-bar-append menubar menu_item)
  (gtk-menu-bar-append menubar menu_item)
)

(define (gui-menu-new)
  (gtk-menu-new)
)

(define (gui-menu-item-new label)
  (gtk-menu-item-new-with-label label)
)

(define (gui-menu-separator-new)
  (gtk-menu-item-new)
)

(define (gui-menu-append menu item)
  (gtk-menu-append menu item)
)

(define (gui-menu-item-connect item func)
  (gtk-signal-connect item  "activate"
    (lambda ()
      (if (selection-cancel)
        (begin
          (set! *COMMAND_CACHE* (cdr func))
          ; execute the new command
          (gui-entry-execute (car func))
        )
      )
    )
  )
)

(define (gui-submenu-set submenu item)
  (gtk-menu-item-set-submenu item submenu)
)

